@echo off
setlocal enabledelayedexpansion enableextensions

	rem Usage: 
	::rem 	%1="C:\CAMS\SubmissionFiles\2011_12_14\213\FTPdetectinfo_scanned_213.txt"
	::rem 	%2="C:\CAMS\SubmissionFiles\2011_12_14\213\FTPdetectinfo_scanned_213_header.txt"
	::rem 	%3="C:\CAMS\SubmissionFiles\2011_12_14\213\FTPdetectinfo_scanned_213_282.txt"
	rem 

:CHECKHELP
	echo.%*|find /i "/?">nul:
	if %errorlevel% equ 0 goto :HELP
	echo.%*|find /i "/h">nul:
	if %errorlevel% equ 0 goto :HELP
	echo.%*|find /i "/help">nul:
	if %errorlevel% equ 0 goto :HELP
	echo.
goto :SETUP

:SETUP
	call "%~dp0AutoCams.setup.bat" "%~dpnx0"
	call "%~dp0indent_setup.bat"

	call "!bat_exedir!\ReadParams.bat"

	!bat_echolog!
	!bat_echolog! =============================================================
	!bat_echolog! %date% %time% - Version: !bat_vers! - %~dpnx0 [%*]
	!bat_echolog! [!bat_batchfile!:SETUP %*]  Please wait...
	!bat_pushecho!
	

	SET bat_returncode=0
	set bat_Header=11
	set bat_Trailer=0

	set bat_dir=%~1
	set bat_dirname=%~2
	set bat_camera=%~3
	set bat_ConfOrScan=%~4
	set bat_count=%~5

	set bat_SourceDetectFile=%~1

	set bat_TargetHeaderFile=%~2
	set bat_TargetDetectFile=%~3

	set bat_Script=!bat_exedir!\StripHeader.vbs
	set VB=echo^>^>"%bat_Script%" 
goto :MAIN


:MAIN
	cd 1>nul 2>"%bat_Script%"

	%VB% SourceFile="!bat_SourceDetectFile!"
	%VB% HeaderFile="!bat_TargetHeaderFile!"
	%VB% TargetFile="!bat_TargetDetectFile!"
	%VB% FileName="!bat_SourceDetectFile!"
	%VB% Set oFSO = CreateObject("Scripting.FileSystemObject") 
	%VB% If oFSO.GetFile(FileName).Size ^> 0 Then 
	%VB%   sNewName = "!bat_TargetHeaderFile!" 
	%VB%   Set oInFile = oFSO.OpenTextFile(FileName) 
	%VB%   aData = Split(oInFile.ReadAll, VbCrLf) 
	%VB%   If UBound(aData) ^>= !bat_Header! Then 
	%VB%     Set oOutFile = oFSO.OpenTextFile(sNewName, 2, True) 
	%VB%     For i = 0 To !bat_Header! 
	%VB%       oOutFile.WriteLine aData(i) 
	%VB%     Next 
	%VB%     oOutFile.Close 
	%VB%   End If 
	%VB%   oInFile.Close 
	%VB% End If 
	%VB% Set oFSO = CreateObject("Scripting.FileSystemObject") 
	%VB% If oFSO.GetFile(FileName).Size ^> 0 Then 
	%VB%   sNewName = "!bat_TargetDetectFile!" 
	%VB%   Set oInFile = oFSO.OpenTextFile(FileName) 
	%VB%   aData = Split(oInFile.ReadAll, VbCrLf) 
	%VB%   If UBound(aData) ^>= !bat_Header! Then 
	%VB%     Set oOutFile = oFSO.OpenTextFile(sNewName, 2, True) 
	%VB%     For i = !bat_Header! To UBound(aData) - 1
	%VB%       oOutFile.WriteLine aData(i) 
	%VB%     Next 
	%VB%     oOutFile.Close 
	%VB%   End If 
	%VB%   oInFile.Close 
	%VB% End If 

	call cscript //nologo "%bat_Script%"
	rem del "%bat_Script%"

goto :DONE


EXAMPLE to strip the headers from all the files in the 2012_05_20 directory
        of all FTPdetectinfo_scanned*.txt files:
	for /f "usebackq tokens=*" %a in (`dir "C:\d\cams\Temp\Coincidence\2012_05_20\FTPdetectinfo_scanned*.txt" /s/b /a-d /on`) do ( 
		call "c:\d\cams\stripHeaderVBS.bat" "%a" "%a_header.txt" "%a_stripped.txt"
	)


:HELP
	@echo off
	echo %~nx0
	echo.
	echo Usage: %~nx0 "^<source file^>" "^<stripped file^>" "^header file^>"
	echo.
	echo Strips the header from the detect source file and saves the results in 
	echo the output header file.  This prepares the files for coincidence processing
	echo which later merges the files together and adds its own header.
	echo.
	echo   Reads the detect file:    "^<source file^>"
	echo   Outputs the detect file:  "^<header file^>"
	echo   Outputs the header:       "^<stripped file^>"
	echo.
	echo Example ^(This is what the Submission script runs^):
	echo     call "C:\CAMS\StripHeaderVBS.bat" "C:\CAMS\SubmissionFiles\2011_12_14\214\ConfirmedFiles\FTPdetectinfo_0214_2011_12_14.txt" "C:\CAMS\SubmissionFiles\2011_12_14\214\EmailFiles\FTPdetectinfo_0214_2011_12_14_confirmed.txt" "C:\CAMS\SubmissionFiles\2011_12_14\214\EmailFiles\FTPdetectinfo_0214_2011_12_14_confirmed_header.txt"
	echo     call "C:\CAMS\StripHeaderVBS.bat" "C:\CAMS\SubmissionFiles\2011_12_14\214\ArchivedFiles\FTPdetectinfo_0214_2011_12_14.txt"  "C:\CAMS\SubmissionFiles\2011_12_14\214\EmailFiles\FTPdetectinfo_0214_2011_12_14_scanned.txt"   "C:\CAMS\SubmissionFiles\2011_12_14\214\EmailFiles\FTPdetectinfo_0214_2011_12_14_scanned_header.txt"
	echo.
	echo The first command strips the header from the source detect files and 
	echo outputs the results and the stripped headers to a different name in 
	echo a different directory.
	echo.
	echo.
	echo.
	echo.

exit /b 9

:DONE
!bat_poplog! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
!bat_echolog! [%~0 DONE bat_returncode=!bat_returncode!]
exit /b !bat_returncode!

