

	rem This script is a subroutine that must be called from another script that 
	rem already has the following variables defined:
	rem   bat_log
	rem   bat_echolog
	rem   bat_push
	rem   bat_pop
	rem   bat_logdir

	rem This routine logs the output of a command by running it
	rem within a loop
:LOGEXEC 
	rem [out] !bat_logexec_returncode!

	!bat_echolog! [!bat_batchfile!:LOGEXEC] %*
	!bat_push!
	
	set bat_logexeccommand=%*
	set bat_logexec_returncode=
	set bat_errorlevel=
	set bat_logexec_padding=                         
	
	if "!bat_logdir!" equ "" (
		rem echo.~~~~~~~~~~~~~~~~~~~~~changing bat_logdir from "!bat_logdir!" to "!bat_exedir!\Logs"
		set bat_logdir=!bat_exedir!\Logs
	)

		rem The [`%*`] actuall executes the command.  The output
		rem from the command is queued into a buffer until the
		rem command is complete.  Then, the for loop echologs
		rem that output at the current indent level.
		
	set /a bat_logexec_counter=0
:LOGEXECLOG2
	rem Handling nested calls
	set bat_logexec_log=!bat_logdir!\indent_logexec.bat.!bat_logexec_counter!.log
	if exist "!bat_logexec_log!" (
		set /a bat_logexec_counter+=1
		goto :LOGEXECLOG2
	)

	if /i "!bat_logexeccommand:~0,4!" equ "set " (
		echo.%*|find /i "=">nul:
		if !errorlevel! equ 0 (
			rem !bat_echolog! Executing command:[!bat_logexeccommand!}}"!bat_logexec_log!" 2}1]
			!bat_logexeccommand!
			set bat_errorlevel=!errorlevel!

				rem If it's a set command, the log the new value
			for /f "tokens=1 delims==" %%W in ("!bat_logexeccommand!") do (
				%%W>>"!bat_logexec_log!" 2>&1
			)

		) else (
			rem !bat_echolog! Executing command:[!bat_logexeccommand!}}"!bat_logexec_log!" 2}1]
			%*>>"!bat_logexec_log!" 2>&1
			set bat_errorlevel=!errorlevel!
		)
	) else (
		rem !bat_echolog! Executing command:[!bat_logexeccommand!}}"!bat_logexec_log!" 2}1]
		%*>>"!bat_logexec_log!" 2>&1
		set bat_errorlevel=!errorlevel!
	)

	set bat_logexec_returncode=!bat_errorlevel!

	if defined bat_errorlevel (
		!bat_log! bat_errorlevel=!bat_errorlevel!
	)

	if exist "!bat_logexec_log!" (
		for /f "usebackq tokens=1* delims=]" %%V in (`find /n /v "" ^< "!bat_logexec_log!"`) do (
			echo.!bat_logexec_padding!!bat_pushstring!%%W
			echo.!bat_logexec_padding!!bat_pushstring!%%W>>"!bat_logfile!"
			echo.!bat_logexec_padding!!bat_pushstring!%%W>>"!bat_logfile_full!"
		)

		if defined bat_logexec_log (
			del "!bat_logexec_log!" 2>&1
		) else (
			!bat_echolog! ERROR [!bat_batchfile!:LOGEXECLOG] Dangerous command:del "!bat_logexec_log!"
		)
	    set /a bat_logexec_counter-=1
	)

	rem !bat_echolog! bat_logexec_returncode=!bat_logexec_returncode!

:LOGEXEC_END
!bat_pop!
!bat_echolog! [RETURN !bat_batchfile!:LOGEXEC] [bat_logexec_returncode=!bat_logexec_returncode!] [%*]
!bat_echolog!
	set bat_logexec_padding=
	set bat_logexeccommand=
rem !bat_pause! [RETURN !bat_batchfile!:LOGEXEC] [bat_logexec_returncode=!bat_logexec_returncode!] [%*]
exit /b !bat_logexec_returncode!



