  @echo off
setlocal enabledelayedexpansion enableextensions
rem MakeArchiveDateZip.bat
rem This script is supposed to zip a directory using seven zip.

:CHECKHELP


	echo.%*|find /i "/?">nul:
	if %errorlevel% equ 0 goto :HELP
	echo.%*|find /i "/h">nul:
	if %errorlevel% equ 0 goto :HELP
	echo.%*|find /i "/help">nul:
	if %errorlevel% equ 0 goto :HELP
	
	if /i "%~1" neq "" (
		if /i "%~2" neq "" (
			goto :SETUP
		)
	)

	goto :HELP
goto :SETUP

	
	
:SETUP
	call "%~dp0AutoCams.setup.bat" "%~dpnx0"
	call "%~dp0indent_setup.bat"

	call "!bat_exedir!\ReadParams.bat"

	!bat_echolog!
	!bat_echolog! =============================================================
	!bat_echolog! %date% %time% - Version: !bat_vers! - %~dpnx0 [%*]
	!bat_echolog! [!bat_batchfile!:SETUP %*]  Please wait...
	!bat_pushecho!
	
	set bat_startlocation=!bat_exedir!&					rem C:\CAMS
	set bat_startdrive=%~d0&				rem C:

	set bat_returncode=0
!bat_pause! MakeArchiveDateZip.bat

	call :PARSEARGS %*
	rem call :READPARAMS
goto :MAIN

	
:MAIN
!bat_pushecho! [GOTO !bat_batchfile!:MAIN] %*
	call :MAKEZIP "!bat_targetdir!" "!bat_dirname!"

:MAIN_END
!bat_pushecho! [MAIN_END] GOTO :DONE
GOTO :DONE



:PARSEARGS
!bat_pushecho! [CALL !bat_batchfile!:PARSEARGS] %*
	set bat_camera=%~1
	
	set bat_sourcedirname=%~2
	set bat_sourcedirbase=%~dp2::
	set bat_sourcedirbase=!bat_sourcedirbase:\::=!
	set bat_sourcedirbase=!bat_sourcedirbase:::=!
	
	set bat_captureddate=%~nx2
	
	set bat_targetdirname=%~3

:PARSEARGS_END
!bat_popecho! [RETURN !bat_batchfile!:PARSEARGS] [!bat_camera!, !bat_captureddate!, !bat_sourcedirname!, !bat_targetdirname!]
!bat_return!



	rem 16. Make Transmit Zip *************************************
:MAKEZIP
!bat_pushecho! [CALL !bat_batchfile!:MAKEZIP] %*
	
	!bat_logexeclog! set bat_tempsrc=!bat_sourcedirname!
	!bat_logexeclog! set bat_tempdest=!bat_targetdirname!

	!bat_logexeclog! set bat_zipfile=!bat_targetdirname!\!bat_captureddate!.zip

:MZ_SEVENZIP

	if exist "!bat_zipfile!" (
		set /p bat_choice='!bat_zipfile!' already exists. Do you want to erase it and create a new one? 
		if /i "!bat_choice!" equ "n" goto :MAKEZIP_END
		if /i "!bat_choice!" neq "y" goto :MZ_SEVENZIP
	)
	
	call :SEVENZIP "!bat_tempsrc!" "!bat_tempdest!"
	
	if not exist "!bat_zipfile!" (
		!bat_echolog!     ERROR - Failed to create zip file: "!bat_zipfile!"
	) else (
		!bat_echolog!     SUCCESS - "!bat_zipfile!"
	)

:MAKEZIP_END
!bat_popecho! [RETURN !bat_batchfile!:MAKEZIPAUTO] ["!bat_zipfile!"]
!bat_return!






:SEVENZIP
!bat_pushecho! [CALL !bat_batchfile!:SEVENZIP]
	!bat_logexec! call "!bat_exedir!\7za.exe" a -tzip "!bat_zipfile!" "!bat_tempsrc!"
	set bat_retval=!bat_logexec_returncode!
	set bat_retval=0

	if !bat_retval! neq 0 (
		!bat_echolog! '    ERROR - Failed to create the zip file...
		!bat_echolog! '    call "!bat_exedir!\7za.exe" a -tzip "!bat_zipfile!" "!bat_tempsrc!"
		!bat_echolog! '    errorlevel=!bat_retval!
	) else (
		if exist "!bat_zipfile!" (
			call :PURGESOURCEDIR
			!bat_logexec! move /y "!bat_sourcedirname!" "!bat_sourcedirname!"
		) else (
			!bat_echolog! '    ERROR - Failed to create the zip file...
			!bat_echolog! '    call "!bat_exedir!\7za.exe" a -r -tzip "!bat_zipfile!" "!bat_tempsrc!"
			!bat_echolog! '    errorlevel=!bat_retval!
		)
	)
:SEVENZIP_END
!bat_popecho! [RETURN !bat_batchfile!:SEVENZIP] [errorlevel=!bat_retval!]
%bat_return%


:PURGESOURCEDIR
!bat_pushecho! call :PURGESOURCEDIR [%*]
	!bat_pushecho! '    for /f "usebackq tokens=*" ..b in ^(`dir "!bat_sourcedirname!" /s/b /ad /on`^) do ^(
	for                    /f "usebackq tokens=*" %%b in  (`dir "!bat_sourcedirname!" /s/b /ad /on`) do (
		!bat_pushecho! '    for /f "usebackq tokens=*" %%c in ^(`dir "%%~b" /s/b /ad /on`^) do ^(
		for                    /f "usebackq tokens=*" %%c in (`dir "%%~b" /s/b /ad /on`) do (
			echo.%%c|find /i "MailFiles">nul:
			if !errorlevel! neq 0 (
				if /i "%%~c" neq "" (
					!bat_logexec! del /s /q "%%~c"
					!bat_logexec! rd  /s /q "%%~c"
				) else (
					!bat_echolog! ERROR [!bat_batchfile!:PURGESOURCEDIR] Dangerous: del /s /q "%%~c"
					!bat_pause!
					exit /b 98
				)
			) else (
				!bat_echolog! Skipping removal of: "%%~c" ..........................
			)
		)
		!bat_popecho! ^)
	)
	!bat_popecho! ^)

:PURGESOURCEDIR_END
!bat_popecho! [RETURN !bat_batchfile!:PURGESOURCEDIR] []
%bat_return%





:READPARAMS
!bat_pushlog! [CALL !bat_batchfile!:READPARAMS]

	!bat_logexeclog! CALL "!bat_exedir!\ReadParams.bat"

:READPARAMS_END
!bat_poplog! [RETURN !bat_batchfile!:READPARAMS] [!bat_paramsfile!=!bat_retval!]
!bat_log!
!bat_return!








:HELP
	@echo off
	echo.
	echo %~nx0
	echo.
	echo Usage: %~nx0 camera ^<"SourceDir"%^> [^<TargetDir^>]]
	echo.
	echo Creates a zip file of the specified directory using seven zip.
	echo.
	echo.
	echo Example:
	echo        %~nx0 299 "C:\CAMS\SubmissionFiles\2012_03_01"
	echo.
	echo Another example to process all the dates in September, 2011:
	echo     for /f "usebackq tokens=*" %%a in ^(`dir "D:\CAMS\SubmissionFiles\2011_09_*" /b /ad /on`^) do ^(call "makearchivedatezip.bat" 213 "d:\cams\SubmissionFiles\%%~a" "d:\cams\SubmissionFiles"^)
exit /b 9



:DONE
	!bat_popecho!
	!bat_echolog!
	!bat_echolog! Done with %0 %*
	!bat_echolog! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	!bat_echolog!
