@echo off
setlocal ENABLEEXTENSIONS ENABLEDELAYEDEXPANSION

echo BATCH SCRIPT: %~f0
echo.


set return=goto :eof
set return_val=exit /b
set return_retval=exit /b !retval!

echo %0 %*


:CHECKHELP
    echo.%*|find /i "/?">nul:
    if %errorlevel% equ 0 goto :HELP

    echo.%*|find /i "/h"
    if %errorlevel% equ 0 goto :HELP

    echo.%*|find /i "/help"
    if %errorlevel% equ 0 goto :HELP


:MAIN
	set retval=3
	rem call :STARTTIMER
	call :SETDEFAULTS %*
	call :SETSWITCHES %*
	call :LOOPFORFILE
!return_retval!


	rem This routine will loop and wait continuously until
	rem either the file appears or the timeout occurs.
:LOOPFORFILE
@echo :LOOPFORFILE "!wait_path!\!wait_filename!"
	if not exist "!wait_path!\!wait_filename!" (
		start /w wait 5
		goto :LOOPFORFILE
	) else (
		echo Found "!wait_path!\!wait_filename!"
		set ret_val=0
	)
!return_retval!


:CALCDATE
!return_val! 0



:SETDEFAULTS 
	rem echo %0 %*

	set wait_default_timeout=300
	set md5_timer_file=timer_waitforfiletoappear.txt
	set retval=3
	set wait_interval=5
	
	set wait_utildir=%~dp0::
		rem Remove trailing backslash
		set wait_utildir=!wait_utildir:\::=!
		set wait_utildir=!wait_utildir:::=!

	set wait_filename=::missing filename
	set wait_nextmode=false
	set wait_timeout=!wait_default_timeout!
	set wait_unlimited=false
	set wait_verbosemode=false
	rem Needs to have an interval value too
!return_val! 0

	
:SETSWITCHES	
	echo.%*|find /i "/f">nul:
	if %errorlevel% equ 0 call :GETARGPAIR /f wait_filename %*

	echo.%*|find /i "/n">nul:
	if %errorlevel% equ 0 call :GETARGSINGLE /n wait_nextmode %*

	echo.%*|find /i "/p">nul:
	if %errorlevel% equ 0 call :GETARGPAIR /p wait_path %*

	echo.%*|find /i "/t">nul:
	if %errorlevel% equ 0 call :GETARGPAIR /t wait_timeout %*

	echo.%*|find /i "/u">nul:
	if %errorlevel% equ 0 call :GETARGSINGLE /u wait_unlimited %*

	echo.%*|find /i "/v">nul:
	if %errorlevel% equ 0 call :GETARGSINGLE /v wait_verbosemode %*

	echo.%*|find /i "/i">nul:
	if %errorlevel% equ 0 call :GETARGPAIR /i wait_interval %*
set wait_
pause
goto :DONE


:GETARGPAIR
	set lookfor=%1
	set varname=%2
    :CONTINUE1
	rem echo if !lookfor! equ !lookfor! (
	if %1 equ !lookfor! (
		rem echo set !varname!=%2
		set !varname!=%2
		shift
		shift
		goto :BREAK1
	) else (
		shift
		goto :CONTINUE1
	)

    :BREAK1
!return_val! 0


:GETARGSINGLE
	set lookfor=%1
	set varname=%2
    :CONTINUE2
	rem echo if %1 equ !lookfor! (
	if %1 equ !lookfor! (
		rem echo set !varname!=%2
		set !varname!=true
		shift
		shift
		goto :BREAK2
	) else (
		shift
		goto :CONTINUE2
	)

    :BREAK2
goto :EOF


:STARTTIMER
rem echo on
	rem Check to see if timer is changing
	
	set md5_test_timer_file=false
	set md5_timer_file=%~dpnx0_timer.txt
	
	if exist "!md5_timer_file!" (
		set md5_test_timer_file=true
		echo 1>"!md5_timer_file!"
	)
	
	if !md5_test_timer_file! equ false (
		start "%~dp0timer.bat" cmd /k ""%~dp0timer.bat" "!md5_timer_file!" 3600"
	) else (
		for /F "usebackq" %%t in ("!md5_timer_file!") do (
			set /a timer_first=%%t
		)
		start /w wait 5
		for /F "usebackq" %%t in ("!md5_timer_file!") do (
			set /a timer_last=%%t
		)
		if /i !timer_first! equ !timer_last! (
			start "%~dp0timer.bat"  cmd /k ""%~dp0timer.bat" "!md5_timer_file!" 36000"
		)
	)
echo off
!return!


:TIMERSTART
rem	echo !md5_timer_file!
	if exist "!md5_timer_file!" set md5_use_timer_file=true
	if !md5_use_timer_file! equ false (
		rem
	) else (
		for /F "usebackq" %%t in ("!md5_timer_file!") do (
			set /a timer_first=%%t
		)
	)
goto :EOF

:TIMEREND

	if exist "!md5_timer_file!" set md5_use_timer_file=true
	if !md5_use_timer_file! equ false (
		set tp_output= 
	) else (
		for /f "usebackq" %%t in ("!md5_timer_file!") do (
			set /a timer_last=%%t
		)

		set /a timer_delta=!timer_last!-!timer_first!
		if !timer_delta! equ 0 set /a timer_delta=1
		rem echo !timer_delta!


		set tp_size1=%1
		set tp_size2=            %1b
		set /a tp_seconds=!timer_delta!
		set tp_bb1=!tp_size2:~12,3!
		set tp_kb1=!tp_size2:~12,6!
		set tp_mb1=!tp_size2:~12,9!
		set tp_gb1=!tp_size2:~12,12!
		set tp_test=!tp_size2:~12,12!
		set /a tp_digits=!tp_bb1!

		set /a tp_count=0
		set /a tp_length=0
		set tp_loop_var=x
		for /L %%c in (0,1,12) do (
			set tp_loop_var=!tp_test:~%%c,1!
			rem echo %%c, tp_loop_var=!tp_loop_var!
			if "!tp_loop_var!" equ "b" (
				set /a tp_length=%%c
				rem echo %%c  "!tp_loop_var!"  "!tp_length!"
			) else (
				rem echo %%c "!tp_loop_var!"  "!tp_length!"
			)
		)
	if !tp_length! LSS 13 set tp_radix=9
	if !tp_length! LSS 10 set tp_radix=6
	if !tp_length! LSS 7 set tp_radix=3
	if !tp_length! LSS 4 set tp_radix=0

	rem if !tp_length! LSS 13 set tp_suffix=  GB/sec
	if !tp_length! LSS 10 set tp_suffix=  MB/sec
	if !tp_length! LSS 7 set tp_suffix= KB/sec
	if !tp_length! LSS 4 set tp_suffix=  B/sec


	set /a tp_offset=!tp_length!-!tp_radix!

	set tp_stem=
	set /a tp_loop=!tp_offset!-1
	for /L %%d in (0,1,!tp_loop!) do (
		if %%d equ 0 (
			set tp_stem=!tp_size1:~%%d,1!
		) else (
			set tp_stem=!tp_stem!!tp_size1:~%%d,1!
		)
	) 

	set /a tp_digits=!tp_stem!
	set /a tp_digits2=!tp_bb1:~0,1!
	set /a tp_throughput=!tp_digits!/!timer_delta!
		set tp_output=[!tp_throughput!!tp_suffix!]
	)
goto :EOF


:HELP
	set retval=4
	rem	WaitForFileToAppear.bat
	rem	Loops until the specified file is found.
	rem	Needs a default timeout
	rem	Need to be able to override the timeout
	rem	Need to specify a path/dir to watch
	rem	Need to be able to return an error code (use EXIT /B retval)
	rem	Would be cool to be able to watch for any file to appear in the folder:
	rem     - do a dir /b, output to a file, wait, do it again, use for /f to 
	rem       compare the files. The calling program passes in an arg the
	rem       file name of a text file that returns the found filename
	rem     - Need an option for handling if more than one file appears
	rem       in the same timeframe. Maybe both outputfile.txt and outputfile-multi.txt
	rem	How about a mode that allows for waiting for a process to appear
	rem     and return the processID and imagename, and path name?
	rem     Needs an interval value
	
	rem Examples:
	rem	waitforfiletoappear /p "c:\temp" /f "brazil1.vmx"
	rem     waitforfiletoappear /t 300 /u /v /n /f junk.txt /p c:\temp
	
	
	echo Batch script that waits for a file to appear.
	echo.
	echo Usage:      WaitForFileToAppear filename
	echo.
	echo Options:
	echo             /f         name of file to wait for
	echo             /n         Next mode - doesn't really start waiting until
	echo                        the file is there and goes away, waiting for 
	echo                        the next one
	echo             /p         path to directory the file should appear in.
	echo                        If omitted, current directory is the default
	echo             /t sec     Override timeout (default is 300 secs [5min])
	echo             /u         Waits indefinitely
	echo             /v         verbose mode
	echo.
	echo Returns:    0          If file has appeared and detected
	echo             1          If timeout happened
	echo             2          If directory no longer available
	echo                        (Could be a network path - disconnected or
	echo                         someone deleted the dir)
	echo             3          Some other error
	echo             4          Help text was displayed
goto :DONE




:DONE
exit /b !retval!


